;----------------------------------------------------------------------
; Programmname : TEHOEHE.LSP    - Version: 3.0 - fr AutoCAD Version 13
; Aufgabe      : ndert die Hhe der ausgewhlten Texte
;                ------------ (c) 1997 by Ralph Kferstein ------------
;----------------------------------------------------------------------
; SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE
;----------------------------------------------------------------------
; Autor: Dipl.-Ing. R. Kferstein * Stifterstr. 25 * 67065 Ludwigshafen 
;        CAD/EDV-Dienstleistungen
;	 CAD-Zeichen- & Konstruktionsservice
;	 Video-/Multimediaproduktionen
;	 Softwareentwicklung (Autolisp/V-Basic/T-Basic/EXCEL/Access/Foxro)
;        Tel./Fax: 0621 - 574658
;----------------------------------------------------------------------
; ---------- Dieses Programm knnen Sie 4 Wochen lang testen ----------
; Bei lngerem Gebrauch mssen Sie sich bei mir registrieren lassen !!!
; Schicken Sie hierfr bitte einen Brief (1BESTELL.TXT) an die o.a.
; Adresse/Faxnummer.
;-----------------------------------------------------------------------
; Weitere Programme fr AutoCAD finden Sie in der Datei 1WEITER.TXT
;-----------------------------------------------------------------------
; Ich erstellte fr Sie auch firmenspez. Programme fr AutoCAD (Telearbeit)
;-----------------------------------------------------------------------
; Ich lehne jegliche Garantie oder Haftung fr direkte oder indirekte
; (auch konstruktive) Schden ab. Weiterhin bernehme ich keine Garantie
; fr die Funktion des Programms.
;-----------------------------------------------------------------------
; Fehlerroutine 
(defun Abbruch (s)
   (if (/= s "Function cancelled")
       (princ (strcat "\nFehler: " s))
   )
   (setvar "CLAYER" AltLayer)
   (graphscr)
   (SETVAR "cmdecho" 1)
   (SETVAR "blipmode" 1)
   (SETVAR "highlight" 1)
   (SETVAR "TEXTSIZE" AltTexthoehe)
   (SETQ *error* olderr)
   (princ)
)
;-----------------------------------------------------------------------
;Winkel von Altgrad ins Bogenma konvertieren
(defun aib (w) (* pi (/ w 180.)))
;-----------------------------------------------------------------------
; Winkel von Bogenma nach Altgrad konvertieren
(defun bia (b) (* (/ b pi) 180.))
;-----------------------------------------------------------------------
; Tangens - Funktion
(defun tan (w) (/ (sin w) (cos w)))
;-----------------------------------------------------------------------
; Arcus-Sinus - Funktion
(defun asin (x)
   (setq radi (- 1 (* x x)))
   (setq nen (sqrt radi))
   (setq arg (/ x nen))
   (setq winb (atan arg))
)
;-----------------------------------------------------------------------
; Phytagoras
(defun phyt (c a)
   (SETQ CC (* C C))
   (SETQ AA (* A A))
   (SETQ Laenge (SQRT(- CC AA)))
)
;-----------------------------------------------------------------------
;Mastabfaktor - Umrechnung
(defun mass (x) (/ x m))
;-----------------------------------------------------------------------
(defun Vorgaben ()
  (SETQ olderr  *error*)
  (SETQ *error* ABBRUCH)
  (setq AltBemFaktor (getvar "DIMLFAC"))
  (SETQ AltLayer (getvar "CLAYER"))
  (setq AltPDSIZE (getvar "pdsize"))
  (setq AltPDMODE (getvar "pdmode"))
  (SETQ AltTexthoehe (getvar "TEXTSIZE"))
  (SETVAR "cmdecho" 0)
  (SETVAR "blipmode" 0)
  (SETQ Vollinie025 "VOLL-025")
  (SETQ Vollinie035 "VOLL-035")
  (SETQ Vollinie05 "VOLL-05")
  (SETQ Vollinie07 "VOLL-07")
  (setq LOESCHEN "LOESCHEN")
  (SETQ Masslinie "BEMASSUNG")
  (SETQ Mittellinie "STRP-025")
  (SETQ Schraffurlinie "SCHRAFFUR")
  (SETQ VerdeckteLinie025 "STRI-025")
  (SETQ VerdeckteLinie035 "STRI-035")
  (SETQ Text025 "TEXT-025")
  (SETQ Text035 "TEXT-035")
  (SETQ Text05 "TEXT-05")
  (SETQ Text07 "TEXT-07")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------  P R  F V E R S I O N  --  4 Wochen lang kostenlos zum Testen  -----")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------------------  (c) 1997 by  Dipl.-Ing. Ralph Kferstein  --------------")
  (prompt "\n----------------------- Tel./Fax: 0 6 2 1 - 5 7 4 6 5 8  -------------------")
  (prompt "\n----------------------------------------------------------------------------")
)
;----------------------------------------------------------------------
(defun Endesequenz ()
  (setvar "DIMLFAC" AltBemFaktor)
  (setvar "CLAYER" AltLayer)
  (setvar "PDSIZE" AltPDSIZE)
  (setvar "PDMODE" AltPDMODE)
  (setvar "TEXTSIZE" AltTexthoehe)
  (graphscr)
  (SETQ *error* olderr)
  (SETVAR "blipmode" 1)
  (SETVAR "cmdecho" 1)
  (SETVAR "HIGHLIGHT" 1) 
  (PRINC)
)
;-----------------------------------------------------------------------
;Hauptprogramm
(DEFUN C:TEHOEHE ()
  (Vorgaben)
 (SETQ Textliste(SSGET))
  (IF Textliste
       (PROGN
         (INITGET 1"Faktor")
         (SETQ AHOEHE(GETVAR "textsize"))
         (SETQ Info (STRCAT "Bitte die neue Texthhe eingeben: "))
         (SETQ NHOEHE(GETDIST Info)Durchlauf 0 Anzahl(SSLENGTH Textliste)HILF2 NIL)
         (WHILE(< Durchlauf Anzahl)
             (SETQ Text(ENTGET(SSNAME Textliste Durchlauf)))
             (IF 
                (AND 
                   (= "TEXT" (CDR(ASSOC 0 Text)))

                   (/= (SETQ Ausrichtung(CDR(ASSOC 72 Text))) 3) 
                )
                (PROGN
                  (IF (AND (> Ausrichtung 0)(< Ausrichtung 5))
                        (SETQ HILF(*(IF HILF2 NHOEHE(/ NHOEHE(CDR(ASSOC 40 Text))))
	        (DISTANCE(SETQ HILF3(CDR(ASSOC 11 Text)))
	        (SETQ Hilf4(CDR(ASSOC 10 Text)))))Text(SUBST(CONS 10(POLAR HILF3(ANGLE HILF3 Hilf4)HILF))
	        (ASSOC 10 Text)Text))
                  )
                  (IF (= Ausrichtung 5)
	        (SETQ Text(SUBST(CONS 41(*(/(IF HILF2 1(CDR(ASSOC 40 Text)))NHOEHE)
	        (CDR(ASSOC 41 Text))))
	        (ASSOC 41 Text)Text))
                  )
                  (ENTMOD(SUBST(CONS 40(IF HILF2(* NHOEHE(CDR(ASSOC 40 Text)))NHOEHE))
                  (ASSOC 40 Text)Text)))
               )
            (SETQ Durchlauf(1+ Durchlauf))
         )
      )
   )

  (Endesequenz)
)
